
DROP TYPE ENAME_LIST;
DROP TYPE ENAME_TYPE;

CREATE TYPE ENAME_TYPE AS OBJECT (
   ENAME  VARCHAR2(30));
/

CREATE TYPE ENAME_LIST AS TABLE OF ENAME_TYPE;
/

CREATE OR REPLACE FUNCTION ENAME_PIPE
   RETURN ENAME_LIST PIPELINED 
IS
   v_EName  ENAME_TYPE;
   CURSOR C_EMP_INFO IS 
      SELECT FIRST_NAME || ' ' || LAST_NAME ENAME
      FROM EMP_INFO
      WHERE EMPNO < 10;
BEGIN
   FOR i In C_EMP_INFO 
   LOOP
      V_EName := ENAME_TYPE(i.ENAME);
      PIPE ROW(v_EName);
   END LOOP;
   RETURN;  
END;
/

SELECT *
FROM TABLE(ENAME_PIPE);


